package com.example.module.admin.req;

import com.example.frame.base.BaseRequest;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.Pattern;

import org.hibernate.validator.constraints.Length;
import xyz.wbsite.wsqlite.anonation.TableField;

import java.util.regex.Matcher;

/**
 * MappingCreateRequest - 映射新增
 *
 * @author author
 * @version 0.0.1
 * @since 2019-09-28
 */
public class MappingCreateRequest extends BaseRequest {

    @NotBlank(message = "映射名称不能为空")
    private String name;

    @NotBlank(message = "服务端口不能为空")
    @Pattern(regexp = "^[0-9]*$", message = "服务端口必须是数字")
    private String servicePort;

    @NotBlank(message = "映射路径不能为空")
    @Pattern(regexp = "/|/[a-zA-Z][a-zA-Z0-9_]*/", message = "映射路径须是/开始结束，中间为字母数字及_组合")
    private String context;

    @NotBlank(message = "映射类型不能为空")
    private String type;

    @NotBlank(message = "映射地址不能为空")
    private String location;

    private String bz;

    public String getServicePort() {
        return servicePort;
    }

    public void setServicePort(String servicePort) {
        this.servicePort = servicePort;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getContext() {
        return context;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public void setContext(String context) {
        this.context = context;
    }

    public String getLocation() {
        return location;
    }

    public void setLocation(String location) {
        this.location = location;
    }

    public String getBz() {
        return bz;
    }

    public void setBz(String bz) {
        this.bz = bz;
    }
}
